#include "troxintro.h"

#define MAXBALLS 400

void intro(void)
{
    typedef struct {
	signed short x,y,z,dx,dy,dz;
	unsigned char c;
    } Ball;
    Ball * ball=NULL;
    signed int ballcount=0; 
    int counter=20;
    int fader=0;
    int dir=1;
    int i;
    char c;
    int p,a;
    int smallballradius;
    bool exitflag=0;
    outtextxy(10,0, "T   USE '+' OR '-' TO    T");
    outtextxy(10,30,"R   CHANGE BALLS' SIZE   R");
    outtextxy(10,60,"O   PRESS ESC TO EXIT    O");
    outtextxy(10,90,"X   OR SPACE TO START    X");
    displaystatus();
    do {
        smallballradius=getsmallballradius();
	counter++;
	if (ballcount>MAXBALLS/smallballradius) {ballcount--;}
	if ((counter>=10)&(ballcount<(MAXBALLS/smallballradius))) {
	    counter=0;
	    ballcount++;
	    ball=(Ball*)realloc((void*)ball,ballcount*sizeof(Ball));
	    if (ball==NULL) {printf("troxintro: could not get enough memory!\n");exit(1);}
	    ball[ballcount-1].x=rnd(WIDTH-2*smallballradius)+smallballradius;
	    ball[ballcount-1].y=smallballradius;
	    ball[ballcount-1].z=0;
	    ball[ballcount-1].dx=rnd(8)+1;
	    ball[ballcount-1].dy=rnd(4)+1;
	    ball[ballcount-1].dz=rnd(4)+1;
	    ball[ballcount-1].c=rnd(4);
	}
	for (i=0;i<ballcount;i++) {
	    ball[i].x+=ball[i].dx;
	    if (ball[i].x<smallballradius) {
		ball[i].x=smallballradius;ball[i].dx=rnd(5)+1;
	    }
	    if (ball[i].x>=WIDTH-smallballradius) {
		ball[i].x=WIDTH-smallballradius;ball[i].dx=-rnd(5)-1;
	    }
	    ball[i].y+=ball[i].dy;
	    if (ball[i].y<smallballradius) {
		ball[i].y=smallballradius;ball[i].dy=rnd(5)+1;
	    }
	    if (ball[i].y>=HIGHT-smallballradius) {
		ball[i].y=HIGHT-smallballradius;ball[i].dy=-rnd(3)-1;
	    }
	    ball[i].z+=ball[i].dz;
	    if (ball[i].z<=smallballradius-DEPTH/2) {ball[i].dz=rnd(5)+1;}
	    if (ball[i].z>=DEPTH/2-smallballradius) {ball[i].dz=-rnd(5)-1;}
	    drawdemoball(ball[i].x,ball[i].y,ball[i].z,ball[i].c);
	}
	displayimage();
	clearimage();
	if (((fader<50)&&(dir==1))||((fader>0)&&(dir==-1))) {
	    fader+=dir;
	    fadepal(fader);
	}
	c=vga_getkey();
	if ((c=='+')&&(dir==1)) {sendshortmessage(-2,1);}
	if ((c=='-')&&(dir==1)) {sendshortmessage(-3,1);}
	if (c==27) {sendshortmessage(-1,1);}
	if (c==32) {sendshortmessage(0,1);}

	if (getshortmessage(p,a,false)) {
	    if (a==1) {
		if (p==-2) {setsmallballradius(smallballradius+1);}
		if (p==-3) {setsmallballradius(smallballradius-1);}
		if (p==-1) {dir=-1;exitflag=true;}
		if (p== 0) {dir=-1;}
	    }
	}
    } 
    while (fader>0);
    free(ball);
    if (exitflag) {printf("Program aborted by user!\n");exit(0);}
}
