// troxtimer
// timing- and raw keyboard functions
// last change 1999-01-02
// Robin Gruber

#ifndef TROXTIMER_H
#define TROXTIMER_H


#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <signal.h>
#include <sys/time.h>
#include <vgakeyboard.h>
#include "troxmath.h"
#include "troxgyro.h"

// after 400 cycles idle Trox assumes that somthing went rong
#define TIMEOUT 400 

int inittimer(int ms, World * w);

void stoptimer(void);

void resettimer(void);

int gettimer(void);

void waituntil(const int &count);

bool escpressed(void);

#endif
